﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using SilverlightApp.SampleService;

namespace SilverlightApp
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            ISampleService service = CreateServiceClient();
            
            int a = Convert.ToInt32(dividendTextBox.Text);
            int b = Convert.ToInt32(divisorTextBox.Text);

            service.BeginDivide(a, b, OnDivideCompleted, service);
        }

        private void OnDivideCompleted(IAsyncResult asyncResult)
        {
            ISampleService service = (ISampleService)asyncResult.AsyncState;

            Dispatcher.BeginInvoke(delegate
            {
                try
                {
                    int c = service.EndDivide(asyncResult);
                    resultTextBlock.Text = c.ToString();
                }
                catch (Exception ex)
                {
                    string exceptionType = ex.GetType().Name;
                    MessageBox.Show("Exception of type " + exceptionType + " occurred:\r\n\r\n" + ex.Message, exceptionType, MessageBoxButton.OK);
                }
            });
        }

        /// <summary>
        /// Set textboxes to some example values that will cause a division by zero.
        /// </summary>
        private void DemoException_Click(object sender, RoutedEventArgs e)
        {
            divisorTextBox.Text = "0";

            if (dividendTextBox.Text.Length == 0)
            {
                dividendTextBox.Text = "42";
            }
        }

        /// <summary>
        /// Return client proxy based on the selected behavior extensions
        /// </summary>
        private ISampleService CreateServiceClient()
        {
            // Find the RadioButton that is currently checked
            RadioButton selected = RadioGroup.Children.OfType<RadioButton>().Single(r => r.IsChecked == true);

            // Use the client endpoint based on the Tag property of the RadioButton
            return new SampleServiceClient("Service" + selected.Tag.ToString());
        }
    }
}
